# Enum rustc_middle::mir::interpret::ValidationErrorKind

source ·

    pub enum ValidationErrorKind<'tcx> {
    Show 28 variants    PointerAsInt {
            expected: ExpectedKind,
        },
        PartialPointer,
        PtrToUninhabited {
            ptr_kind: PointerKind,
            ty: Ty<'tcx>,
        },
        PtrToStatic {
            ptr_kind: PointerKind,
        },
        ConstRefToMutable,
        ConstRefToExtern,
        MutableRefToImmutable,
        UnsafeCellInImmutable,
        NullFnPtr,
        NeverVal,
        NullablePtrOutOfRange {
            range: WrappingRange,
            max_value: u128,
        },
        PtrOutOfRange {
            range: WrappingRange,
            max_value: u128,
        },
        OutOfRange {
            value: String,
            range: WrappingRange,
            max_value: u128,
        },
        UninhabitedVal {
            ty: Ty<'tcx>,
        },
        InvalidEnumTag {
            value: String,
        },
        UninhabitedEnumVariant,
        Uninit {
            expected: ExpectedKind,
        },
        InvalidVTablePtr {
            value: String,
        },
        InvalidMetaSliceTooLarge {
            ptr_kind: PointerKind,
        },
        InvalidMetaTooLarge {
            ptr_kind: PointerKind,
        },
        UnalignedPtr {
            ptr_kind: PointerKind,
            required_bytes: u64,
            found_bytes: u64,
        },
        NullPtr {
            ptr_kind: PointerKind,
        },
        DanglingPtrNoProvenance {
            ptr_kind: PointerKind,
            pointer: String,
        },
        DanglingPtrOutOfBounds {
            ptr_kind: PointerKind,
        },
        DanglingPtrUseAfterFree {
            ptr_kind: PointerKind,
        },
        InvalidBool {
            value: String,
        },
        InvalidChar {
            value: String,
        },
        InvalidFnPtr {
            value: String,
        },
    }

## Variants§

§

### PointerAsInt

#### Fields

§`expected: ExpectedKind`
§

### PartialPointer

§

### PtrToUninhabited

#### Fields

§`ptr_kind: PointerKind`
§`ty: Ty<'tcx>`
§

### PtrToStatic

#### Fields

§`ptr_kind: PointerKind`
§

### ConstRefToMutable

§

### ConstRefToExtern

§

### MutableRefToImmutable

§

### UnsafeCellInImmutable

§

### NullFnPtr

§

### NeverVal

§

### NullablePtrOutOfRange

#### Fields

§`range: WrappingRange`
§`max_value: u128`
§

### PtrOutOfRange

#### Fields

§`range: WrappingRange`
§`max_value: u128`
§

### OutOfRange

#### Fields

§`value: String`
§`range: WrappingRange`
§`max_value: u128`
§

### UninhabitedVal

#### Fields

§`ty: Ty<'tcx>`
§

### InvalidEnumTag

#### Fields

§`value: String`
§

### UninhabitedEnumVariant

§

### Uninit

#### Fields

§`expected: ExpectedKind`
§

### InvalidVTablePtr

#### Fields

§`value: String`
§

### InvalidMetaSliceTooLarge

#### Fields

§`ptr_kind: PointerKind`
§

### InvalidMetaTooLarge

#### Fields

§`ptr_kind: PointerKind`
§

### UnalignedPtr

#### Fields

§`ptr_kind: PointerKind`
§`required_bytes: u64`
§`found_bytes: u64`
§

### NullPtr

#### Fields

§`ptr_kind: PointerKind`
§

### DanglingPtrNoProvenance

#### Fields

§`ptr_kind: PointerKind`
§`pointer: String`
§

### DanglingPtrOutOfBounds

#### Fields

§`ptr_kind: PointerKind`
§

### DanglingPtrUseAfterFree

#### Fields

§`ptr_kind: PointerKind`
§

### InvalidBool

#### Fields

§`value: String`
§

### InvalidChar

#### Fields

§`value: String`
§

### InvalidFnPtr

#### Fields

§`value: String`

## Trait Implementations§

source§

### impl<'tcx> Debug for ValidationErrorKind<'tcx>

source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more

## Auto Trait Implementations§

§

### impl<'tcx> DynSend for ValidationErrorKind<'tcx>

§

### impl<'tcx> DynSync for ValidationErrorKind<'tcx>

§

### impl<'tcx> Freeze for ValidationErrorKind<'tcx>

§

### impl<'tcx> !RefUnwindSafe for ValidationErrorKind<'tcx>

§

### impl<'tcx> Send for ValidationErrorKind<'tcx>

§

### impl<'tcx> Sync for ValidationErrorKind<'tcx>

§

### impl<'tcx> Unpin for ValidationErrorKind<'tcx>

§

### impl<'tcx> !UnwindSafe for ValidationErrorKind<'tcx>

## Blanket Implementations§

source§

### impl<T> Aligned for T

source§

#### const ALIGN: Alignment = _

Alignment of `Self`.
source§

### impl<T> Any for T
where T: 'static + ?Sized,

source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
source§

### impl<T> Borrow<T> for T
where T: ?Sized,

source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
source§

### impl<T, R> CollectAndApply<T, R> for T

source§

#### fn collect_and_apply<I, F>(iter: I, f: F) -> R
where I: Iterator<Item = T>, F: FnOnce(&[T]) -> R,

Equivalent to `f(&iter.collect::<Vec<_>>())`.

§

#### type Output = R

§

### impl<T> Filterable for T

§

#### fn filterable( self, filter_name: &'static str ) -> RequestFilterDataProvider<T, fn(_: DataRequest<'_>) -> bool>

Creates a filterable data provider with the given name for debugging. Read more
source§

### impl<T> From<T> for T

source§

#### fn from(t: T) -> T

Returns the argument unchanged.

source§

### impl<T> Instrument for T

source§

#### fn instrument(self, span: Span) -> Instrumented<Self>

Instruments this type with the provided `Span`, returning an `Instrumented` wrapper. Read more
source§

#### fn in_current_span(self) -> Instrumented<Self>

Instruments this type with the current `Span`, returning an `Instrumented` wrapper. Read more
source§

### impl<T, U> Into<U> for T
where U: From<T>,

source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source§

### impl<P> IntoQueryParam<P> for P

source§

#### fn into_query_param(self) -> P

source§

### impl<T> MaybeResult<T> for T

§

#### type Error = !

source§

#### fn from(_: Result<T, <T as MaybeResult<T>>::Error>) -> T

source§

#### fn to_result(self) -> Result<T, <T as MaybeResult<T>>::Error>

§

### impl<T> Pointable for T

§

#### const ALIGN: usize = _

The alignment of pointer.
§

#### type Init = T

The type for initializers.
§

#### unsafe fn init(init: <T as Pointable>::Init) -> usize

Initializes a with the given initializer. Read more
§

#### unsafe fn deref<'a>(ptr: usize) -> &'a T

Dereferences the given pointer. Read more
§

#### unsafe fn deref_mut<'a>(ptr: usize) -> &'a mut T

Mutably dereferences the given pointer. Read more
§

#### unsafe fn drop(ptr: usize)

Drops the object pointed to by the given pointer. Read more
source§

### impl<T> Same for T

§

#### type Output = T

Should always be `Self`
source§

### impl<'tcx, T> ToPredicate<'tcx, T> for T

source§

#### fn to_predicate(self, _tcx: TyCtxt<'tcx>) -> T

source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.
§

### impl<V, T> VZip<V> for T
where V: MultiLane<T>,

§

#### fn vzip(self) -> V

source§

### impl<Tcx, T> Value<Tcx> for T
where Tcx: DepContext,

source§

#### default fn from_cycle_error( tcx: Tcx, cycle_error: &CycleError, _guar: ErrorGuaranteed ) -> T

source§

### impl<T> WithSubscriber for T

source§

#### fn with_subscriber<S>(self, subscriber: S) -> WithDispatch<Self>
where S: Into<Dispatch>,

Attaches the provided `Subscriber` to this type, returning a `WithDispatch` wrapper. Read more
source§

#### fn with_current_subscriber(self) -> WithDispatch<Self>

Attaches the current default `Subscriber` to this type, returning a `WithDispatch` wrapper. Read more
source§

### impl<'a, T> Captures<'a> for T
where T: ?Sized,

§

### impl<T> ErasedDestructor for T
where T: 'static,

§

### impl<T> MaybeSendSync for T
where T: Send + Sync,

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 80 bytes

Size for each variant:

- `PointerAsInt`: 1 byte
- `PartialPointer`: 0 bytes
- `PtrToUninhabited`: 16 bytes
- `PtrToStatic`: 1 byte
- `ConstRefToMutable`: 0 bytes
- `ConstRefToExtern`: 0 bytes
- `MutableRefToImmutable`: 0 bytes
- `UnsafeCellInImmutable`: 0 bytes
- `NullFnPtr`: 0 bytes
- `NeverVal`: 0 bytes
- `NullablePtrOutOfRange`: 48 bytes
- `PtrOutOfRange`: 48 bytes
- `OutOfRange`: 80 bytes
- `UninhabitedVal`: 8 bytes
- `InvalidEnumTag`: 24 bytes
- `UninhabitedEnumVariant`: 0 bytes
- `Uninit`: 1 byte
- `InvalidVTablePtr`: 24 bytes
- `InvalidMetaSliceTooLarge`: 1 byte
- `InvalidMetaTooLarge`: 1 byte
- `UnalignedPtr`: 24 bytes
- `NullPtr`: 1 byte
- `DanglingPtrNoProvenance`: 32 bytes
- `DanglingPtrOutOfBounds`: 1 byte
- `DanglingPtrUseAfterFree`: 1 byte
- `InvalidBool`: 24 bytes
- `InvalidChar`: 24 bytes
- `InvalidFnPtr`: 24 bytes